//generated class! do not change
package name.panitz.crempel.tool.jugs; 
import java.util.List;
import java.util.ArrayList;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

import java.io.*;

import name.panitz.crempel.tool.CrempelTool;

public class JugsGui extends JFrame 
                     implements CrempelTool
{

  public String getDescription(){return "Jugs";}
  public void startUp(){new JugsGui(new Jugs()).setVisible(true);};

  private final Jugs jugs;

  private ImportsDialog importsDialog;
  private FontSelectDialog fontSelectDialog;

  JTextArea inputArea = new JTextArea(15,80);
  JTextArea outputArea = new JTextArea(15,80);

  private JLabel imagePanel
    = new JLabel(new ImageIcon("images/jugs.jpg"));

  private JPanel textPanel = new JPanel();

  private JButton executeButton = new JButton("execute");
  private JButton clearButton = new JButton("clear");   

  private JRadioButton expressionModeButton
    = new JRadioButton("expression mode");
  private JRadioButton statementModeButton
    = new JRadioButton("statemente mode");
  private ButtonGroup group = new ButtonGroup();

  private JPanel buttonPanel = new JPanel();
  private JPanel radioPanel = new JPanel();

  private JPanel controlPanel = new JPanel();

  private JMenuBar menuBar=new JMenuBar();
  private JMenu fileMenu= new JMenu("File");
  private JMenu optionsMenu= new JMenu("Options");
  private JMenu helpMenu= new JMenu("Help");


  private JMenuItem quitMenu
   = new JMenuItem("quit",KeyEvent.VK_Q);
  private JMenuItem executeMenu
   = new JMenuItem("execute",KeyEvent.VK_X);
  private JMenuItem clearMenu
   = new JMenuItem("clear",KeyEvent.VK_C);

  private JMenuItem importsMenu
   = new JMenuItem("imports...",KeyEvent.VK_H);
  private JMenuItem fontMenu
   = new JMenuItem("font...",KeyEvent.VK_F);


  private JMenuItem aboutMenu= new JMenuItem("about");

  
  class TextAreaOutputStream extends java.io.OutputStream{
    JTextArea area;
    TextAreaOutputStream(JTextArea area){
      this.area=area;
    }

    public void write(int b) {
      area.append(new Character((char)b).toString() );
    }
  }

  public JugsGui (){this(new Jugs());}

  public JugsGui (final Jugs jugs){
    super("Jugs: the interactive Java environment");  
    this.jugs=jugs;

    Font [] fonts =  GraphicsEnvironment
                      .getLocalGraphicsEnvironment()
                      .getAllFonts();
 
    for (int i = 0;i<fonts.length;i++){
      Font f = fonts[i];
      if(f.getFontName().equals("Courier") 
         && f.getStyle()==Font.PLAIN){
        f=f.deriveFont((float)18);
        inputArea.setFont(f);
        outputArea.setFont(f);
        break;
      }
    }

    if (jugs.expressionMode) expressionModeButton.setSelected(true);
    else statementModeButton.setSelected(true);

    group.add(expressionModeButton);
    group.add(statementModeButton);

    expressionModeButton.addActionListener(
      new ActionListener(){
        public void actionPerformed(ActionEvent e){ 
      jugs.expressionMode = true;
    }
      }
    );


    statementModeButton.addActionListener(
      new ActionListener(){
        public void actionPerformed(ActionEvent e){ 
      jugs.expressionMode = false;
        }
      }
    );

    executeButton.addActionListener(new ExecuteActionListener());

    clearButton.addActionListener(new ClearActionListener());

    Container panel = getContentPane();

    buttonPanel.setLayout(new GridLayout(2,1));
    buttonPanel.add(executeButton);
    buttonPanel.add(clearButton);

    radioPanel.setLayout(new GridLayout(2,1));
    radioPanel.add(expressionModeButton);
    radioPanel.add(statementModeButton);

    controlPanel.setLayout(new BorderLayout());
    controlPanel.setBackground(java.awt.Color.RED);
    controlPanel.add(buttonPanel,BorderLayout.NORTH);
    controlPanel.add(imagePanel,BorderLayout.CENTER);
    controlPanel.add(radioPanel,BorderLayout.SOUTH);

    textPanel.setLayout(new BorderLayout());

    Component inputPane = new JScrollPane(inputArea);
    textPanel.add(inputPane,BorderLayout.NORTH);
    textPanel.add(new JPanel(),BorderLayout.CENTER);

    Component outputPane = new JScrollPane(outputArea);
    textPanel.add(outputPane,BorderLayout.SOUTH);
    outputArea.setEditable(false);

    panel.setLayout(new BorderLayout());
    panel.add(controlPanel,BorderLayout.WEST);
    panel.add(textPanel,BorderLayout.CENTER);
    


    importsDialog = new ImportsDialog(this);
    fontSelectDialog = new FontSelectDialog(this,inputArea.getFont().getSize());

    setJMenuBar(menuBar);

    optionsMenu.setMnemonic(KeyEvent.VK_O);
    optionsMenu
      .getAccessibleContext()
      .setAccessibleDescription("to set options");

    fileMenu.setMnemonic(KeyEvent.VK_F);
    fileMenu.getAccessibleContext()
            .setAccessibleDescription("quit etc...");

    importsMenu
      .getAccessibleContext()
      .setAccessibleDescription("to add items to the import list");
    optionsMenu.add(importsMenu);

    importsMenu.addActionListener(
      new ActionListener(){
        public void actionPerformed(ActionEvent e){ 
          importsDialog.setVisible(true);
        }
      }
    );

    fontMenu
      .getAccessibleContext()
      .setAccessibleDescription("to set the font size");
    optionsMenu.add(fontMenu);

    fontMenu.addActionListener(
      new ActionListener(){
        public void actionPerformed(ActionEvent e){ 
          fontSelectDialog.setVisible(true);
        }
      }
    );


    quitMenu
      .getAccessibleContext()
      .setAccessibleDescription("quit jugs");
    fileMenu.add(executeMenu);
    fileMenu.add(clearMenu);
    fileMenu.add(quitMenu);

    clearMenu.addActionListener(new ClearActionListener());
    executeMenu.addActionListener(new ExecuteActionListener());

    quitMenu.addActionListener(
      new ActionListener(){
        public void actionPerformed(ActionEvent e){ 
          System.exit(0);
        }
      }
    );


    helpMenu.add(aboutMenu);

    aboutMenu.addActionListener(new AboutActionListener(this));

    menuBar.add(fileMenu);
    menuBar.add(optionsMenu);
    menuBar.add(helpMenu);

    pack();
  }

  class ClearActionListener implements ActionListener{
     public void actionPerformed(ActionEvent e){ 
       inputArea.setText("");
     }
  }


  class ExecuteActionListener implements ActionListener{
     public void actionPerformed(ActionEvent e){ 
       outputArea.setText("");
       System.setOut(new PrintStream(new TextAreaOutputStream(outputArea)));
       System.setErr(new PrintStream(new TextAreaOutputStream(outputArea)));
       jugs.execute(inputArea.getText(),importsList());
       System.setOut(System.out);
       System.setErr(System.err);
     }

     List<String> importsList(){
       List<String> result=new ArrayList<String>();
       java.util.Enumeration<String> imps = importsDialog.listModel.elements();
       while (imps.hasMoreElements())
         result.add(imps.nextElement());
       return result;
     }
  }

  class AboutActionListener implements ActionListener{
    Component c;
    AboutActionListener(Component c){this.c=c;}  
    public void actionPerformed(ActionEvent e){ 
      JOptionPane.showMessageDialog(c, ABOUT_STRING);
    }
  }

  static String ABOUT_STRING
    =   "Jugs: Java UmGebungs System v."+Jugs.VERSION
     +"\n2003 Sven Eric Panitz";

  public static void main(String [] _){
    JugsGui gui = new JugsGui(new Jugs());
    gui.setVisible(true);
  }
}

